﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Serialization;
using Syncfusion.Windows.PropertyGrid;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Configuration configuration = new Configuration();
        Configuration.NormalMode normalMode = new Configuration.NormalMode();
        Configuration.StepMode stepMode = new Configuration.StepMode();

        public MainWindow()
        {
            InitializeComponent();

            PropertyGrid1.SelectedObject = normalMode;
            PropertyGrid1.PropertyExpandMode = PropertyExpandModes.NestedMode;

            PropertyGrid2.SelectedObject = stepMode;
            PropertyGrid2.PropertyExpandMode = PropertyExpandModes.NestedMode;
        }


        public void serializeToXML(Configuration obj)
        {
            XmlSerializerNamespaces namespaces = new XmlSerializerNamespaces();
            namespaces.Add("", "");
            XmlSerializer serializer = new XmlSerializer(typeof (Configuration));
            TextWriter textwriter = new StreamWriter("GUICONTROL.xml");
            serializer.Serialize(textwriter, obj, namespaces);
            textwriter.Close();
        }

        private void button_Click(object sender, RoutedEventArgs e)
        {
            normalMode = (Configuration.NormalMode)PropertyGrid1.SelectedObject;
            stepMode = (Configuration.StepMode)PropertyGrid2.SelectedObject;
            serializeToXML(configuration);
            Refresh();
        }

        private void Refresh()
        {
            XmlSerializer xs = new XmlSerializer(typeof(Configuration));
            FileStream read = new FileStream("GUICONTROL.xml", FileMode.Open, FileAccess.Read, FileShare.Read);
            Configuration configuration = (Configuration)xs.Deserialize(read);
            PropertyGrid1.SelectedObject = normalMode;
            PropertyGrid2.SelectedObject = stepMode;
        }
    }
}
